pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature > Class Template Reference

Normal-based feature signature estimation class. More...

`#include <pcl/features/normal_based_signature.h>`

Inheritance diagram for pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >:

## Public Types

using | FeatureCloud = pcl::PointCloud< PointFeature >
using | Ptr = shared_ptr< NormalBasedSignatureEstimation< PointT, PointNT, PointFeature > >
using | ConstPtr = shared_ptr< const NormalBasedSignatureEstimation< PointT, PointNT, PointFeature > >
Public Types inherited from pcl::FeatureFromNormals< PointT, PointNT, PointFeature >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointT, PointNT, PointFeature > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointT, PointNT, PointFeature > >
Public Types inherited from pcl::Feature< PointT, PointFeature >
using | BaseClass = PCLBase< PointT >
using | Ptr = shared_ptr< Feature< PointT, PointFeature > >
using | ConstPtr = shared_ptr< const Feature< PointT, PointFeature > >
using | KdTree = pcl::search::Search< PointT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointFeature >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| NormalBasedSignatureEstimation ()
| Empty constructor, initializes the internal parameters to the default values. More...
void | setN (std::size_t n)
| Setter method for the N parameter - the length of the columns used for the Discrete Fourier Transform. More...
std::size_t | getN ()
| Returns the N parameter - the length of the columns used for the Discrete Fourier Transform. More...
void | setM (std::size_t m)
| Setter method for the M parameter - the length of the rows used for the Discrete Cosine Transform. More...
std::size_t | getM ()
| Returns the M parameter - the length of the rows used for the Discrete Cosine Transform. More...
void | setNPrime (std::size_t n_prime)
| Setter method for the N' parameter - the number of columns to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector. More...
std::size_t | getNPrime ()
| Returns the N' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector. More...
void | setMPrime (std::size_t m_prime)
| Setter method for the M' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector. More...
std::size_t | getMPrime ()
| Returns the M' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector. More...
void | setScale (float scale)
| Setter method for the scale parameter - used to determine the radius of the sampling disc around the point of interest - linked to the smoothing scale of the input cloud. More...
float | getScale ()
| Returns the scale parameter - used to determine the radius of the sampling disc around the point of interest - linked to the smoothing scale of the input cloud. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointT, PointNT, PointFeature >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointT, PointFeature >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (FeatureCloud &output) override
| Abstract feature estimation method. More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointT, PointNT, PointFeature >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointT, PointFeature >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FeatureFromNormals< PointT, PointNT, PointFeature >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointT, PointFeature >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT, typename PointNT, typename PointFeature>
class pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >

Normal-based feature signature estimation class.

Obtains the feature vector by applying Discrete Cosine and Fourier Transforms on an NxM array of real numbers representing the projection distances of the points in the input cloud to a disc around the point of interest. Please consult the following publication for more details: Xinju Li and Igor Guskov Multi-scale features for approximate alignment of point-based surfaces Proceedings of the third Eurographics symposium on Geometry processing July 2005, Vienna, Austria

Note
  These features were meant to be used at keypoints detected by a detector using different smoothing radii (e.g., SmoothedSurfacesKeypoint)

Author
  Alexandru-Eugen Ichim

Definition at line 60 of file normal_based_signature.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT , typename PointNT , typename PointFeature >

using pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::ConstPtr = shared_ptr<const NormalBasedSignatureEstimation<PointT, PointNT, PointFeature> >

Definition at line 71 of file normal_based_signature.h.

## FeatureCloud

template<typename PointT , typename PointNT , typename PointFeature >

using pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::FeatureCloud = pcl::PointCloud<PointFeature>

Definition at line 69 of file normal_based_signature.h.

## Ptr

template<typename PointT , typename PointNT , typename PointFeature >

using pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::Ptr = shared_ptr<NormalBasedSignatureEstimation<PointT, PointNT, PointFeature> >

Definition at line 70 of file normal_based_signature.h.

## Constructor & Destructor Documentation

## NormalBasedSignatureEstimation()

template<typename PointT , typename PointNT , typename PointFeature >

pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::NormalBasedSignatureEstimation | ( |  | ) |

inline

Empty constructor, initializes the internal parameters to the default values.

Definition at line 77 of file normal_based_signature.h.

## Member Function Documentation

## computeFeature()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::computeFeature | ( | FeatureCloud & | output | ) |

override protected virtual

Abstract feature estimation method.

Parameters

  [out] | output | the resultant features

Implements pcl::Feature< PointT, PointFeature >.

Definition at line 46 of file normal_based_signature.hpp.

References pcl::PointCloud< PointT >::points.

## getM()

template<typename PointT , typename PointNT , typename PointFeature >

std::size_t pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::getM | ( |  | ) |

inline

Returns the M parameter - the length of the rows used for the Discrete Cosine Transform.

Definition at line 105 of file normal_based_signature.h.

## getMPrime()

template<typename PointT , typename PointNT , typename PointFeature >

std::size_t pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::getMPrime | ( |  | ) |

inline

Returns the M' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector.

Note
  This value directly influences the dimensions of the type of output points (PointFeature)

Definition at line 135 of file normal_based_signature.h.

## getN()

template<typename PointT , typename PointNT , typename PointFeature >

std::size_t pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::getN | ( |  | ) |

inline

Returns the N parameter - the length of the columns used for the Discrete Fourier Transform.

Definition at line 95 of file normal_based_signature.h.

## getNPrime()

template<typename PointT , typename PointNT , typename PointFeature >

std::size_t pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::getNPrime | ( |  | ) |

inline

Returns the N' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector.

Note
  This value directly influences the dimensions of the type of output points (PointFeature)

Definition at line 120 of file normal_based_signature.h.

## getScale()

template<typename PointT , typename PointNT , typename PointFeature >

float pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::getScale | ( |  | ) |

inline

Returns the scale parameter - used to determine the radius of the sampling disc around the point of interest - linked to the smoothing scale of the input cloud.

Definition at line 147 of file normal_based_signature.h.

## setM()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::setM | ( | std::size_t | m | ) |

inline

Setter method for the M parameter - the length of the rows used for the Discrete Cosine Transform.

Parameters

  [in] | m | the length of the rows used for the Discrete Cosine Transform.

Definition at line 101 of file normal_based_signature.h.

## setMPrime()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::setMPrime | ( | std::size_t | m_prime | ) |

inline

Setter method for the M' parameter - the number of rows to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector.

Note
  This value directly influences the dimensions of the type of output points (PointFeature)

Parameters

  [in] | m_prime | the number of rows from the matrix of DFT and DCT that will be contained in the output

Definition at line 128 of file normal_based_signature.h.

## setN()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::setN | ( | std::size_t | n | ) |

inline

Setter method for the N parameter - the length of the columns used for the Discrete Fourier Transform.

Parameters

  [in] | n | the length of the columns used for the Discrete Fourier Transform.

Definition at line 91 of file normal_based_signature.h.

## setNPrime()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::setNPrime | ( | std::size_t | n_prime | ) |

inline

Setter method for the N' parameter - the number of columns to be taken from the matrix of DFT and DCT values that will be contained in the output feature vector.

Note
  This value directly influences the dimensions of the type of output points (PointFeature)

Parameters

  [in] | n_prime | the number of columns from the matrix of DFT and DCT that will be contained in the output

Definition at line 113 of file normal_based_signature.h.

## setScale()

template<typename PointT , typename PointNT , typename PointFeature >

void pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::setScale | ( | float | scale | ) |

inline

Setter method for the scale parameter - used to determine the radius of the sampling disc around the point of interest - linked to the smoothing scale of the input cloud.

Definition at line 141 of file normal_based_signature.h.

The documentation for this class was generated from the following files:

- pcl/features/normal_based_signature.h
- pcl/features/impl/normal_based_signature.hpp